<template>
    <div class="app-container">
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="40px">
        <el-form-item label="日期">
          <el-date-picker
            v-model="queryParams.performStartDate"
            type="daterange"
            value-format="yyyy-MM-dd"
            placeholder="日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8"  style="margin-left: 0; margin-top: 10px">
        <el-button
          type="primary"
          size="mini"
          icon="el-icon-download"
          :disabled="dataList.length === 0"
          v-hasPermi="['session:session:downloadExcel']"
          @click="handleExport"
          v-loading.fullscreen.lock="handleExportLoading"
          element-loading-text="正在拼命生成数据中..."
          element-loading-spinner="el-icon-loading"
          element-loading-background="rgba(0, 0, 0, 0.5)"
        >导出excel</el-button>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
  
      <el-table ref="tables" v-loading="loading" :data="dataList" border>
        <el-table-column label="序号" align="center" type="index" width="60"></el-table-column>
        <!-- <el-table-column label="剧目名称" align="center" prop="performName" />
        <el-table-column label="票务名称" align="center" prop="goodsName" /> -->
        <el-table-column label="场次日期" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.performDate }}</span>
          </template>
        </el-table-column>
        <el-table-column label="场次" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.performTimeStart }} -- {{ scope.row.performTimeEnd }}</span>
          </template>
        </el-table-column>
        <el-table-column label="销售量" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.saleTotal?scope.row.saleTotal+'张' : '-' }}</span>
          </template>
        </el-table-column>
        <el-table-column label="核销量" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.usedTotal?scope.row.usedTotal+'张' : '-' }}</span>
          </template>
        </el-table-column>
        <el-table-column label="核销率" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.usedRate?scope.row.usedRate+'%' : '-' }}</span>
          </template>
        </el-table-column>
        <el-table-column label="核销上座率" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.occupancyRate?scope.row.occupancyRate+'%' : '-' }}</span>
          </template>
        </el-table-column>
      </el-table>
  
      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
  
    </div>
  </template>
  
  <script>
  
  import { performTimeCount, downTimeCountListXls } from '@/api/statisticalReport/statistics'
  import { exportExcel } from '@/utils/exportexcel'
  import { seatPricePageList } from '@/api/distribution/ticketMr'
  import moment from "moment"
  export default {
    name: "agreement",
    dicts: ['agreement_type'],
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 用户表格数据
        dataList: [],
        // 弹出层标题
        title: "",
  
        // 是否显示弹出层
        open: false,
        // 日期范围
        dateRange: [],
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
        },
        visibleStatus: false,
        newObj: {},
        visibleType: '',
        handleExportLoading: false,
        tableData: {},
        ticketList: [],
        seatList: [],
      };
    },
    created() {
      this.$set(this.queryParams,'performStartDate',moment().format("yyyy-MM-DD"))
      this.getList();
      this.ticketListApi();
    },
    methods: {
      /** 查询列表 */
      getList() {
        this.loading = true;
        if(this.queryParams.time){
          this.queryParams.performStartDate = this.queryParams.time[0];
          this.queryParams.performEndDate = this.queryParams.time[1];
        }
        performTimeCount(this.addDateRange(this.queryParams, this.dateRange))
        .then(response => {
            this.dataList = response.data.rows;
            this.total = response.data.total;
            this.loading = false;
          }
        );
      },
      /** 票务列表查询 */
      ticketListApi() {
        this.ticketList = []
        seatPricePageList(this.addDateRange({pageNum: 1, pageSize: 100}))
          .then(response => {
            let ticketItemList = []
            response.data.rows.forEach(item => {
              if(ticketItemList.indexOf(item.goodsId) == -1){
                this.ticketList.push(item);
                ticketItemList.push(item.goodsId);
              }
            })
          });
      },
      /** 座位类型列表 */
      getSeatTypeList(obj) {
        seatPricePageList(this.addDateRange({pageNum: 1, pageSize: 100, goodsId: obj.goodsId}))
          .then(response => {
            let ticketList = []
            response.data.rows.forEach(item => {
              if(ticketList.indexOf(item.seatTypeId) == -1){
                this.seatList.push(item);
                ticketList.push(item.seatTypeId);
              }
            })
          });
      },
      // 取消按钮
      cancel() {
        this.open = false;
      },
      // 票务改变事件
      goodsChangeEven() {
        this.seatList = [];
        this.$set(this.queryParams, 'seatTypeId', '');
        let selectMap = {goodsId: this.queryParams.goodsId}
        this.getSeatTypeList(selectMap);
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.dateRange = [];
        this.seatList = [];
        this.$set(this.queryParams, 'time', '');
        this.$set(this.queryParams, 'performStartDate', '');
        this.$set(this.queryParams, 'performEndDate', '');
        this.$set(this.queryParams, 'goodsId', '');
        this.$set(this.queryParams, 'seatTypeId', '');
        this.queryParams.pageNum = 1;
        this.handleQuery();
      },
      /**
       * 导出报表
       * @date 2022-10-24
       * @returns {any}
       */
      handleExport() {
        this.$confirm('您确定要导出当前查询的数据吗？', '提示', {
          confirmButtonText: '确定 ',
          cancelButtonText: '取消 ',
          type: 'warning'
        })
          .then(() => {
            this.handleExportLoading = true;
            // const { pageNum, pageSize} = this.params;
            let postMap = {}
            for (let key in this.queryParams) {
              if(key != 'pageNum' && key != 'pageSize'){
                postMap[key] = this.queryParams[key]
              }
            }
            downTimeCountListXls(postMap)
              .then((res) => {
                exportExcel(res, '场次销售分析', '.xlsx');
                this.handleExportLoading = false;
              })
              .catch(() => {
                this.handleExportLoading = false;
              });
          })
          .catch(() => {
            this.$message.info('您已取消导出！');
          });
      },
    }
  };
  </script>
  